Subject: bug#20628: 25.0.50; Incorrect line height for some fonts

From: Clément Pit--Claudel <[email-masked]>
Date: Fri, 29 May 2015 01:35:18 -0700

On 05/29/2015 01:20 AM, Eli Zaretskii wrote:
>> Date: Wed, 27 May 2015 18:20:02 +0300
>> From: Eli Zaretskii <[email-masked]>
>> Cc: [email-masked]
>>
>> The changes are in platform-independent code, but I could only test
>> them on MS-Windows.  So users of Unix and GNU systems who are affected
>> by this problem are encouraged to try the branch and report their
>> experiences, whether good or bad.
>>
>> I will look into merging the branch to master in a few days, barring
>> any grave bugs.
>>
>> TIA
> 
> A bug reported that generated 70 messages describing how important it
> was to fix it, and yet no one -- not a single soul -- says anything
> when the solution seems to be at hand?  Isn't that strange?

Hi Eli,

Thanks a lot for taking the time to put this patch together! I've been pretty busy these last few days, and just got around testing your patch (on Linux Mint). The approach of only activating per-glyph metrics when the font provides absurd ascent and descent values seems reasonable. 

> Would people who urged us to fix this please try the
> scratch/large-fonts branch, and see if it's good enough to be merged
> to master?  I can post the diffs here, if that would make things
> easier for someone.

The patch partially solves the problem for me, but I noticed a few problems after running (set-frame-font "Latin Modern Math")
* When the cursor is at the end of the file, on an empty line, it has a very height.
* The modeline is still very tall
* The fix seems to only apply to certain characters. The line that I mentioned in my original email, in particular, is still very tall. In other words, when trying the following three lines in a Latin Modern Math buffer, the last line is much too tall:

𝓝  ;; This is still very tall
∏∑∫ ;; This is a bit taller than the normal height, which is great
ABC ;; This has the normal height, which is also great

> 
> Once again, the Unix-specific portions of the changes are untested,
> and need at least to be verified to do a reasonable job with the
> offending fonts.
> 
> If there are no comments in a few days, I will proceed with the merge.
> 
> TIA
> 
>